Index: main/trunk/greenstone2/perllib/inexport.pm
===================================================================
--- main/trunk/greenstone2/perllib/inexport.pm	(revision 32539)
+++ main/trunk/greenstone2/perllib/inexport.pm	(revision 32540)
@@ -680,4 +680,5 @@
     push @$plugout,("-gzip_output")                if ($gzip);
     push @$plugout,("-output_handle",$out)         if (defined $out);
+    push @$plugout,("-site_name",$self->{'site'})  if (defined $self->{'site'});
 
     push @$plugout,("-xslt_file",$xsltfile)        if (defined $xsltfile && $xsltfile ne "");
Index: main/trunk/greenstone2/perllib/plugouts/BasePlugout.pm
===================================================================
--- main/trunk/greenstone2/perllib/plugouts/BasePlugout.pm	(revision 32539)
+++ main/trunk/greenstone2/perllib/plugouts/BasePlugout.pm	(revision 32540)
@@ -44,5 +44,10 @@
 $SIG{__WARN__} = sub {warn($_[0]) unless ($_[0] =~ /Subroutine\s+\S+\sredefined/)};
 
-my $arguments = [ 
+my $arguments = [
+        { 'name' => "site_name",
+	  'desc' => "{BasPlugout.site_name}",
+	  'type' => "string",
+	  'reqd' => "no",
+	  'hiddengli' => "yes" },
        { 'name' => "xslt_file", 
 	'desc' => "{BasPlugout.xslt_file}",
@@ -135,10 +140,19 @@
     # the args, just return the object.
     #print STDERR "#### " . join(",", @${args}) . "\n\n";
+    my $v=0;
     foreach my $strArg (@{$args})
     {
-	if(defined $strArg && $strArg eq "-gsdlinfo")
-	{
-	    $self->{"info_only"} = 1;
-	    return bless $self, $class;
+	if(defined $strArg) {
+	    if($strArg eq "-gsdlinfo")
+	    {
+		$self->{"info_only"} = 1;
+		return bless $self, $class;
+	    }	    
+	    elsif ($strArg eq "-site_name") {
+		$v = $strArg;
+	    }
+	    elsif($v eq "-site_name") {
+		$self->{'site_name'} = $strArg;
+	    }
 	}
     }
Index: main/trunk/greenstone2/perllib/strings.properties
===================================================================
--- main/trunk/greenstone2/perllib/strings.properties	(revision 32539)
+++ main/trunk/greenstone2/perllib/strings.properties	(revision 32540)
@@ -1236,4 +1236,6 @@
 PrintInfo.desc:Most base plugin, handles printing info (using pluginfo.pl) and parsing of the arguments.
 
+PrintInfo.site_name:The name of the Greenstone 3 site. The default site for a GS3 installation is localsite.
+
 ProCitePlugin.desc:A plugin for (exported) ProCite databases
 
@@ -1418,4 +1420,5 @@
 BasPlugout.no_auxiliary_databases:Don't generate archivesinf databases - useful when exporting.
 # '
+BasPlugout.site_name:The name of the Greenstone 3 site. The default site for a GS3 installation is localsite.
 BasPlugout.output_handle: the file descriptor used to receive output data
 BasPlugout.output_info:The reference to an arcinfo object used to store information about the archives.
@@ -1445,5 +1448,5 @@
 METSPlugout.xslt_mets:Transform a mets's docmets.xml with the XSLT in the named file.  
 
-GreenstoneSQLPlugout.desc:Output metadata and/or full text to a MySQL database instead of doc.xml.
+GreenstoneSQLPlugout.desc:Output metadata and/or full text to a MySQL database (named after GS3 site name for GS3 or named greenstone2 for GS2) instead of doc.xml. For Greenstone 3, the database name is the GS3 site name. For Greenstone 2, the database name is greenstone2.
 
 # 
@@ -1454,5 +1457,9 @@
 GreenstoneSQLPlug.process_mode.meta_only:Import stage outputs the metadata to a MySQL database and any text to doc.xml.
 GreenstoneSQLPlug.process_mode.text_only:Import stage outputs the full text to a MySQL database and any metadata to doc.xml.
-
+GreenstoneSQLPlug.db_driver:The database driver. Support has been implemented for MySQL so far, so the default is mysql.
+GreenstoneSQLPlug.db_client_user:The username with which you connect to the (My)SQL database, root by default.
+GreenstoneSQLPlug.db_client_pwd:The password with which you connect to the (My)SQL database.
+GreenstoneSQLPlug.db_host:The hostname on which the (My)SQL database server is running, 127.0.0.1 by default. Other values to try include localhost.
+GreenstoneSQLPlug.db_encoding:The encoding of the contents of the database, utf8 by default. For other options, see https://dev.mysql.com/doc/refman/5.7/en/charset-applications.html. Use the same encoding to write contents to the database with GreenstoneSQLPlugout as to read back in with GreenstoneSQLPlugin.
 
 #